# See at https://www.digitalocean.com/community/tutorials/how-to-install-node-js-on-ubuntu-20-04
- name: Get nodejs facts
  ansible.builtin.package_facts:
    manager: apt

- name: Install nodejs
  vars:
    nodesource_version: 18
    nodesource_setup_path: /tmp/nodesource_setup.sh
  block:
    - name: Download NodeSource setup
      shell: curl -sL https://deb.nodesource.com/setup_{{ nodesource_version }}.x -o {{ nodesource_setup_path }}

    - name: Execute setup
      shell: bash {{ nodesource_setup_path }}

    - name: Install nodejs
      ansible.builtin.apt:
        name:
          - nodejs
        update_cache: yes

    - name: Get nodejs version
      shell: node -v
      register: installed_nodejs_version

    - name: Debug nodejs version
      debug:
        msg: "{{ installed_nodejs_version.stdout }}"
      when: installed_nodejs_version is defined
  always:
    - name: Remove setup file
      file:
        path: "{{ nodesource_setup_path }}"
        state: absent
  when: "'nodejs' not in ansible_facts.packages"